function[imf] = DCTah(im1,im2,bs)
% DCT based image fusion with block bias (eq.7)
% by VPS Naidu, MSDF Lab

[m,n] = size(im1);
hbs = bs/2;
for i=1:bs:m
    for j=1:bs:n
        cb1 = im1(i:i+bs-1,j:j+bs-1);
        cb2 = im2(i:i+bs-1,j:j+bs-1);
        CB1 = dct2(cb1);
        CB2 = dct2(cb2);
        dl = abs(CB1)-abs(CB2)>=0;
        CBF = dl.*CB1+(~dl).*CB2;
        CBF(1:hbs,1:hbs)=0.5*(CB1(1:hbs,1:hbs)+CB2(1:hbs,1:hbs));
        cbf = idct2(CBF);
        imf(i:i+bs-1,j:j+bs-1)=cbf;
    end
end