function[imf] = DCTch(im1,im2,bs)
% DCT based image fusion with block bias (eq.9 & 3)
% by VPS Naidu, MSDF Lab

[m,n] = size(im1);
hbs = bs/2;
for i=1:bs:m
    for j=1:bs:n
        cb1 = im1(i:i+bs-1,j:j+bs-1);
        cb2 = im2(i:i+bs-1,j:j+bs-1);
        CB1 = dct2(cb1);
        CB2 = dct2(cb2);
        CMcb1 = Cmeas(CB1);
        CMcb2 = Cmeas(CB2);
        dl = abs(CMcb1)-abs(CMcb2)>=0;
        CBF = dl.*CB1+(~dl).*CB2;
        CBF(1:hbs,1:hbs)=0.5*(CB1(1:hbs,1:hbs)+CB2(1:hbs,1:hbs));
        cbf = idct2(CBF);
        imf(i:i+bs-1,j:j+bs-1)=cbf;
    end
end

%====================================================

function[C] = Cmeas(I) %eq.3
% contrast at each coefficient
[m,n] = size(I);
E = Ek(I);
for i=1:m
    for j=1:n
        k=1+(i-1+j-1);
        C(i,j) = I(i,j)/(sum(E(1:k)));
    end
end
    
%=====================================================

function[E] = Ek(I) %eq.4
% Compute average amplitude

[m,n] = size(I);
M=m+n-1;
for k=1:M
    in=0;
    for i=1:m
        for j=1:n
            kk=i-1+j-1;
            if (k-1)==kk
                in=in+1;
                EE(k,in)=I(i,j);
            end
        end
    end
end
for k=1:M
    if (k-1)<m
        N=k;
    else
        N=M-k+1;
    end
    E(k)=mean(abs(EE(k,1:N)));
end