function[imf] = DCTe(im1,im2,bs)
% DCT based image fusion with energy (eq.10 & 4)
% by VPS Naidu, MSDF Lab

[m,n] = size(im1);
for i=1:bs:m
    for j=1:bs:n
        cb1 = im1(i:i+bs-1,j:j+bs-1);
        cb2 = im2(i:i+bs-1,j:j+bs-1);
        CB1 = dct2(cb1);
        CB2 = dct2(cb2);
        Ekcb1 = Ek(CB1);
        Ekcb2 = Ek(CB2);
        for ii=1:bs
            for jj=1:bs
                k=ii-1+jj-1;
                if Ekcb1(k+1)>=Ekcb2(k+1)
                    CBF(ii,jj)=CB1(ii,jj);
                else
                    CBF(ii,jj)=CB2(ii,jj);
                end
            end
        end                        
        CBF(1,1)=0.5*(CB1(1,1)+CB2(1,1));
        cbf = idct2(CBF);
        imf(i:i+bs-1,j:j+bs-1)=cbf;
    end
end

function[E] = Ek(I) %eq.4
% Compute average amplitude

[m,n] = size(I);
M=m+n-1;
for k=1:M
    in=0;
    for i=1:m
        for j=1:n
            kk=i-1+j-1;
            if (k-1)==kk
                in=in+1;
                EE(k,in)=I(i,j);
            end
        end
    end
end
for k=1:M
    if (k-1)<m
        N=k;
    else
        N=M-k+1;
    end
    E(k)=mean(abs(EE(k,1:N)));
end